if not _G.ShowXPinChat_text then
			_G.ShowXPinChat_text = {}
			local _path = ModPath .. "text.ini"
			local path = _path:gsub( "/lua", "")
			local file, err = io.open(path, "r")
			if not file then
				file = io.open(path, "w")
				file:write("[$OBJECTIVE: $XPCURRENT XP gained (Total XP: $XPTOTAL)]")
				file:close()
			end
			local file, err = io.open(path, "r")
			if file then
				for line in file:lines() do
				table.insert(_G.ShowXPinChat_text, line)
				end
			file:close()
			end
end

if string.lower(RequiredScript) == "lib/managers/mission/elementexperience" then
	Hooks:PreHook(ElementExperience, "on_executed", "xpchat_on_executed", function (self, instigator)
		if self._editor_name then
		_G.ShowXPinChat_editor_name = self._editor_name
		end
	end)
end

if string.lower(RequiredScript) == "lib/managers/experiencemanager" then
	Hooks:PreHook(ExperienceManager, "mission_xp_award", "xpchat_mission_xp_award_pre", function(self, amount)
		_G.ShowXPinChat_oldxp = self:get_xp_dissected(true, managers.network:session():amount_of_alive_players(), not Utils:IsInCustody())
		_G.ShowXPinChat_oldxp_base = self._global.mission_xp_current and Application:digest_value(self._global.mission_xp_current, false) or 0
	end)

	Hooks:PostHook(ExperienceManager, "mission_xp_award", "xpchat_mission_xp_award_post", function(self, amount)
		local amount_ignore = tonumber(_G.ShowXPinChat:ShowXPinChat_ignore())
		if amount_ignore == nil then
			amount_ignore = 0
		end
		
		if amount >= amount_ignore and _G.ShowXPinChat_oldxp and _G.ShowXPinChat_oldxp_base then
			local objective_filter = "None"
			if _G.ShowXPinChat_editor_name then
				objective_filter = _G.ShowXPinChat_editor_name:gsub( "func_experience_", ""):gsub( "experience_", ""):gsub( "_exp", ""):gsub( "exp_", ""):gsub( "_xp", ""):gsub( "xp_", ""):gsub( "_XP", ""):gsub( "XP_", "")
			end
			
			local totalxp = 0
			local currentxp = 0
			
			if _G.ShowXPinChat:ShowXPinChat_xptype() == 1 then
				totalxp = self:get_xp_dissected(true, managers.network:session():amount_of_alive_players(), not Utils:IsInCustody())
				currentxp = self:experience_string(totalxp-_G.ShowXPinChat_oldxp)
			else
				totalxp = self._global.mission_xp_current and Application:digest_value(self._global.mission_xp_current, false) or 0
				currentxp = self:experience_string(totalxp-_G.ShowXPinChat_oldxp_base)
			end
			
			local user_text = _G._G.ShowXPinChat_text[1]
			local user_text_filter = user_text:gsub( "$OBJECTIVE", objective_filter):gsub( "$XPCURRENT", currentxp):gsub( "$XPTOTAL", self:experience_string(totalxp))
			
			ShowXPinChat:send_message(user_text_filter, _G.ShowXPinChat:ShowXPinChat_messagetype())
		end
	end)
end